#!/usr/bin/ruby -I .
# coding: utf-8

@gm = 3061; @gn = 45; @gr = 26
@vs1 = []; @vs2 = [[135, 19], [1526, 40], [2065, 42], [2728, 17]] # n137745d8-k7l6.130459402950401-gm3061gn45gr26; [1, 8, 56, 392, 2728, 17738, 74218, 42604]; @vs2len = [9, 15, 45, 45]; evens: [0, 0, 0, 16, 1088, 34738, 158386]; (end of 0 x 16 loops)

@n = @gm * @gn
@voltagesSemi = @vs1; @voltages = @vs2
@d = @voltagesSemi.length * 1 + @voltages.length * 2
# @vs1 = []; @vs2 = [[5, 7], [6, 3], [12, 2], [12, 3], [16, 1]] # n256d10-k3l2.5686274509803924-gm32gn8gr3; [1, 10, 90, 155]; @vs2len = [8, 8, 8, 8, 16] k3l 2.5686274509803924 - 2.6666666666666665 (end of 500 x 20 loops)

def semiDirectProduct(x1, y1, x2, y2)
  [(x1 + (@gr ** y1) * x2) % @gm, (y1 + y2) % @gn]
end

def cayleyGraph(vs1, vs2)
  strvol = "voltages: #{vs1}, semiV: #{vs2}"
  @e = (0...@n).map { |i| [] }

  @dupc = 0
  (0...@gm).each { |mi|
    (0...@gn).each { |ni|
      (vs1 + vs2).each { |mv, nv|
        mj, nj = semiDirectProduct(mi, ni, mv, nv)
        i = mi + @gm * ni
        j = mj + @gm * nj
        if @e[i].index(j) == nil # 片方向の枝は @e0 に
          addEdge(@e, i, j)
        else
          # p ["dup", mi, ni, mj, nj, i, j]
          @dupc += 1
        end
      }
    }
  }
  p ["# of dup", @dupc, @dupc / @gm, @dupc / @gn] if @dupc > 0 && @debug

  @e.map! { |ei| ei.sort }
  save(@e, @n, @d, vs1, vs2)

  d = vs1.length + 2 * vs2.length
  
  dist = (0...@n).to_a.map { @n }
  frontier = [0]
  dist[0] = 0
  while frontier.length > 0
    puts "frontier: #{frontier}, #{dist}" if @debug
    nextfrontier = []
    frontier.each { |i|
      di = dist[i]
      @e[i].each { |j|
        if dist[j] > di + 1
          dist[j] = di + 1
          nextfrontier << j
        end
      }
    }
    frontier = nextfrontier
  end
  n = dist.reduce(0) { |s, di|
    if di < @n
      s += 1
    else
      s
    end
  }
  k = dist.max
  l = Rational(dist.reduce(:+), n - 1)
  evc = (0..k).to_a.map { 0 }
  (0...@n).each { |i|
    evc[dist[i]] += 1
  }
  
  puts "# n#{n}d#{d}-k#{k}l#{l.to_f}-gm#{@gm}gn#{@gn}gr#{@gr}, #{evc}]"
  puts "@voltagesSemi = #{vs1}; @voltages = #{vs2}"
  [n, d, k, l]
end

def addEdge(e, i, j)
  e[i] << j
  e[j] << i
end

def save(e, n, d, vs1, vs2)
  return if e.length != n
  fnout = $0.sub('.rb', '.edges')
  puts "write into
  #{fnout}"
  fo = open(fnout, 'w')
  vs1s = vs1.map { |v| "(#{v.join(',')})" }.join('')
  vs1s += ' | ' if vs1s.length > 0
  vs2s = vs2.map { |v| "(#{v.join(',')})" }.join('')
  fo.puts "# Cayley graph"
  fo.puts "# Group m = #{@gm}, n = #{@gn}, r = #{@gr}; Quotient B(#{vs1.length}, #{vs2.length})"
  fo.puts "# Voltages [#{vs1s}#{vs2s}]"
  (0...n).each { |i|
    e[i].sort.each { |j|
      next if i > j
      fo.puts "#{i} #{j}"
    }
  }
  fo.close
end

cayleyGraph(@voltagesSemi, @voltages)
